<template>
  <div class="app-container">
    <el-form :model="queryParams" ref="queryForm" size="small" :inline="true" v-show="showSearch">
      <el-form-item :label="$t('appvipuser.用户id')" prop="userId">
        <el-input
          v-model="queryParams.userId"
          :placeholder="$t('appvipuser.请输入用户id')"
          clearable
          @keyup.enter.native="handleQuery"
        />
      </el-form-item>
      <el-form-item :label="$t('appvipuser.到期时间')" prop="yxtim">
        <el-date-picker clearable
          v-model="queryParams.yxtim"
          type="date"
          value-format="yyyy-MM-dd"
          :placeholder="$t('appvipuser.请选择会员到期时间')">
        </el-date-picker>
      </el-form-item>
      <el-form-item :label="$t('appvipuser.用户名称')" prop="phone">
        <el-input
          v-model="queryParams.phone"
          :placeholder="$t('appvipuser.请输入用户名称')"
          clearable
          @keyup.enter.native="handleQuery"
        />
      </el-form-item>
      <el-form-item :label="$t('appvipuser.用户昵称')" prop="name">
        <el-input
          v-model="queryParams.name"
          :placeholder="$t('appvipuser.请输入用户昵称')"
          clearable
          @keyup.enter.native="handleQuery"
        />
      </el-form-item>
      <el-form-item>
        <el-button type="primary" icon="el-icon-search" size="mini" @click="handleQuery">{{$t('appvipuser.搜索')}}</el-button>
        <el-button icon="el-icon-refresh" size="mini" @click="resetQuery">{{$t('appvipuser.重置')}}</el-button>
      </el-form-item>
    </el-form>

    <el-row :gutter="10" class="mb8">
      <el-col :span="1.5">
        <el-button
          type="warning"
          plain
          icon="el-icon-download"
          size="mini"
          @click="handleExport"
          v-hasPermi="['system:vipuser:export']"
        >{{$t('appvipuser.导出')}}</el-button>
      </el-col>
      <right-toolbar :showSearch.sync="showSearch" @queryTable="getList"></right-toolbar>
    </el-row>

    <el-table v-loading="loading" :data="vipuserList" @selection-change="handleSelectionChange">
      <el-table-column type="selection" width="55" align="center" />
      <el-table-column label="id" align="center" prop="id" />
      <el-table-column :label="$t('appvipuser.用户id')" align="center" prop="userId" />
      <el-table-column :label="$t('appvipuser.会员到期时间')" align="center" prop="yxtim">
        <template slot-scope="scope">
          <span>{{ parseTime(scope.row.yxtim, '{y}-{m}-{d}') }}</span>
        </template>
      </el-table-column>
      <el-table-column :label="$t('appvipuser.用户名称')" align="center" prop="phone" />
      <el-table-column :label="$t('appvipuser.用户昵称')" align="center" prop="name" />
      <el-table-column :label="$t('appvipuser.操作')" align="center" class-name="small-padding fixed-width">
        <template slot-scope="scope">
          <el-button
            size="mini"
            type="text"
            icon="el-icon-edit"
            @click="handleUpdate(scope.row)"
            v-hasPermi="['system:vipuser:edit']"
          >{{$t('appvipuser.详情')}}</el-button>
<!--          <el-button
            size="mini"
            type="text"
            icon="el-icon-delete"
            @click="handleDelete(scope.row)"
            v-hasPermi="['system:vipuser:remove']"
          >删除</el-button> -->
        </template>
      </el-table-column>
    </el-table>

    <pagination
      v-show="total>0"
      :total="total"
      :page.sync="queryParams.pageNum"
      :limit.sync="queryParams.pageSize"
      @pagination="getList"
    />

    <!-- 添加或修改viplist对话框 -->
    <el-dialog :title="title" :visible.sync="open" width="600px" append-to-body>
      <el-form ref="form" :model="form" :rules="rules" :label-width="$t('message.language')=='语言'?'80px':$t('message.language')=='language'?'165px':'220px'">
        <el-form-item :label="$t('appvipuser.用户id')" prop="userId">
          <el-input v-model="form.userId" :placeholder="$t('appvipuser.请输入用户id')" />
        </el-form-item>
        <el-form-item :label="$t('appvipuser.会员到期时间')" prop="yxtim">
          <el-date-picker clearable
            v-model="form.yxtim"
            type="date"
            value-format="yyyy-MM-dd"
            :placeholder="$t('appvipuser.请选择会员到期时间')">
          </el-date-picker>
        </el-form-item>
        <el-form-item :label="$t('appvipuser.用户名称')" prop="phone">
          <el-input v-model="form.phone" :placeholder="$t('appvipuser.请输入用户名称')" />
        </el-form-item>
        <el-form-item :label="$t('appvipuser.用户昵称')" prop="name">
          <el-input v-model="form.name" :placeholder="$t('appvipuser.请输入用户昵称')" />
        </el-form-item>
      </el-form>
      <div slot="footer" class="dialog-footer">
        <el-button type="primary" @click="cancel">{{$t('appvipuser.确定')}}</el-button>
        <el-button @click="cancel">{{$t('appvipuser.取消')}}</el-button>
      </div>
    </el-dialog>
  </div>
</template>

<script>
import { listVipuser, getVipuser, delVipuser, addVipuser, updateVipuser } from "@/api/system/vipuser";

export default {
  name: "Vipuser",
  data() {
    return {
      // 遮罩层
      loading: true,
      // 选中数组
      ids: [],
      // 非单个禁用
      single: true,
      // 非多个禁用
      multiple: true,
      // 显示搜索条件
      showSearch: true,
      // 总条数
      total: 0,
      // viplist表格数据
      vipuserList: [],
      // 弹出层标题
      title: "",
      // 是否显示弹出层
      open: false,
      // 查询参数
      queryParams: {
        pageNum: 1,
        pageSize: 10,
        userId: null,
        yxtim: null,
        phone: null,
        name: null
      },
      // 表单参数
      form: {},
      // 表单校验
      rules: {
        userId: [
          { required: true, message: "用户id不能为空", trigger: "blur" }
        ],
        yxtim: [
          { required: true, message: "会员到期时间不能为空", trigger: "blur" }
        ],
      }
    };
  },
  created() {
    this.getList();
  },
  methods: {
    /** 查询viplist列表 */
    getList() {
      this.loading = true;
      listVipuser(this.queryParams).then(response => {
        this.vipuserList = response.rows;
        this.total = response.total;
        this.loading = false;
      });
    },
    // 取消按钮
    cancel() {
      this.open = false;
      this.reset();
    },
    // 表单重置
    reset() {
      this.form = {
        id: null,
        userId: null,
        yxtim: null,
        phone: null,
        name: null
      };
      this.resetForm("form");
    },
    /** 搜索按钮操作 */
    handleQuery() {
      this.queryParams.pageNum = 1;
      this.getList();
    },
    /** 重置按钮操作 */
    resetQuery() {
      this.resetForm("queryForm");
      this.handleQuery();
    },
    // 多选框选中数据
    handleSelectionChange(selection) {
      this.ids = selection.map(item => item.id)
      this.single = selection.length!==1
      this.multiple = !selection.length
    },
    /** 新增按钮操作 */
    handleAdd() {
      this.reset();
      this.open = true;
      this.title = "添加viplist";
    },
    /** 修改按钮操作 */
    handleUpdate(row) {
      this.reset();
      const id = row.id || this.ids
      getVipuser(id).then(response => {
        this.form = response.data;
        this.open = true;
        this.title = this.$t('appvipuser.查看详情');
      });
    },
    /** 提交按钮 */
    submitForm() {
      this.$refs["form"].validate(valid => {
        if (valid) {
          if (this.form.id != null) {
            updateVipuser(this.form).then(response => {
              this.$modal.msgSuccess("修改成功");
              this.open = false;
              this.getList();
            });
          } else {
            addVipuser(this.form).then(response => {
              this.$modal.msgSuccess("新增成功");
              this.open = false;
              this.getList();
            });
          }
        }
      });
    },
    /** 删除按钮操作 */
    handleDelete(row) {
      const ids = row.id || this.ids;
      this.$modal.confirm('是否确认删除viplist编号为"' + ids + '"的数据项？').then(function() {
        return delVipuser(ids);
      }).then(() => {
        this.getList();
        this.$modal.msgSuccess("删除成功");
      }).catch(() => {});
    },
    /** 导出按钮操作 */
    handleExport() {
      this.download('system/vipuser/export', {
        ...this.queryParams
      }, `vipuser_${new Date().getTime()}.xlsx`)
    }
  }
};
</script>
